<?php namespace Evoluted\RecaptchaFieldType;

use Anomaly\Streams\Platform\Addon\FieldType\FieldType;

class RecaptchaFieldType extends FieldType
{
    protected $inputView = 'evoluted.field_type.recaptcha::recaptcha';

    protected $presenter = RecaptchaFieldPresenter::class;

    protected $required = true;

    protected $config = [
        'disable_label' => true,
        'type' => 'hidden',
    ];

    protected $rules = [
        'valid_recaptcha',
    ];

    protected $validators = [
        'valid_recaptcha' => [
            'handler' => ValidateRecaptcha::class,
            'message' => 'Please ensure you have JavaScript enabled and have completed the recaptcha',
        ],
    ];
}
