<?php

namespace Evoluted\RecaptchaFieldType;

use Illuminate\Http\Request;
use ReCaptcha\ReCaptcha;

class ValidateRecaptcha
{
    /** @var Request */
    private $request;
    /** @var ReCaptcha */
    private $reCaptcha;

    /**
     * @param Request $request
     * @param ReCaptcha $reCaptcha
     */
    public function __construct(Request $request, ReCaptcha $reCaptcha)
    {
        $this->request = $request;
        $this->reCaptcha = $reCaptcha;
    }

    /**
     * @param RecaptchaFieldType $recaptchaFieldType
     * @param $value
     * @return bool
     */
    public function handle(RecaptchaFieldType $recaptchaFieldType, $value)
    {
        $response = $this->reCaptcha->setExpectedHostname($this->request->getHost())
            ->verify($value, $this->request->ip())
        ;

        return $response->isSuccess();
    }
}
